summaryrefslogtreecommitdiff
path: root/lib/talloc/script/abi_checks_gcc.sh
diff options
context:
space:
mode:
authorMichael Adam <obnox@samba.org>2009-08-28 16:04:47 +0200
committerMichael Adam <obnox@samba.org>2009-08-30 00:51:53 +0200
commitc7d9617259bafddd1ce26a5c336885e2d3c6771a (patch)
treecc0f644e8f84314fcb26dac251efc4addcd309cf /lib/talloc/script/abi_checks_gcc.sh
parentd9b193189afb83f02ba68e6360f34cd8c6f59873 (diff)
downloadsamba-c7d9617259bafddd1ce26a5c336885e2d3c6771a.tar.gz
samba-c7d9617259bafddd1ce26a5c336885e2d3c6771a.tar.bz2
samba-c7d9617259bafddd1ce26a5c336885e2d3c6771a.zip
talloc: move the original abi_checks script to script/abi_checks_gcc.sh
Michael
Diffstat (limited to 'lib/talloc/script/abi_checks_gcc.sh')
-rwxr-xr-xlib/talloc/script/abi_checks_gcc.sh34
1 files changed, 34 insertions, 0 deletions
diff --git a/lib/talloc/script/abi_checks_gcc.sh b/lib/talloc/script/abi_checks_gcc.sh
new file mode 100755
index 0000000000..e3d3b042fa
--- /dev/null
+++ b/lib/talloc/script/abi_checks_gcc.sh
@@ -0,0 +1,34 @@
+#!/bin/bash
+
+make clean
+
+mkdir abi
+ABI_CHECKS="-aux-info abi/\$@.X"
+make ABI_CHECK="$ABI_CHECKS" CC="/usr/bin/gcc"
+
+for i in abi/*.X; do cat $i | grep 'talloc\.h'; done | sort | uniq | awk -F "extern " '{ print $2 }' | sort > abi/signatures
+
+cat > abi/exports << EOF
+{
+ global:
+EOF
+cat abi/signatures | awk -F '(' '{ print $1 }' | awk -F ' ' '{ print " "$NF";" }' | tr -d '*' | sort >> abi/exports
+# need to manually add talloc free for backward ABI compat
+echo ' talloc_free;' >> abi/exports
+cat >> abi/exports << EOF
+
+ local: *;
+};
+EOF
+
+rm -fr abi/*.X
+
+diff -u talloc.signatures abi/signatures
+if [ "$?" != "0" ]; then
+ echo "WARNING: Possible ABI Change!!"
+fi
+
+diff -u talloc.exports abi/exports
+if [ "$?" != "0" ]; then
+ echo "WARNING: Export file may be outdated!!"
+fi